#include "midi_b9.h"

int      d_allow_p[detdim];
short    d_allow_l[detdim];
unsigned d_allow_st[detdim];
short    d_allow[max_sky_bytes];
   
/* ************************************************************************** */

int backpro_d(float shdgr[detdim], float sky[skydim], struct log_con *logger, struct backpro *backproj)
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/*                                                                           */        
/* subroutine to backproject a JEM-X shadowgram as provided in shdgr[detdim] */
/*                                                                           */        
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
{
   int det_index, length=0, sky_index, skystep, i, j;
   short  *b_bot;
   float shdgr_val;
   
   static int func_local = -1, local_calling_num=0;
   clock_t calling_TT, TT_now;

   /* function entry timing start */
   if (func_local < 0) {
      func_local = logger->func_used_num++;
      sprintf(logger->func_names[func_local], "backpro_d");
      if (logger->func_used_num > 199) {printf("func_used_num > 199\n"); exit(0);}
   }
   logger->func_calls[func_local]++;
   calling_TT = logger->TT;
   logger->TT = TT_now = clock();
   local_calling_num = logger->func_calling_num;
   logger->func_calling_num = func_local;
   logger->func_times[local_calling_num] += difftime(TT_now, calling_TT);
   /* function entry timing end */
   
   for (i=0; i<skydim; i++) sky[i] = 0.0;
   
   for (i=0; i<detdim; i++) if (backproj->soft_gr[i] <= 0.0) shdgr[i] = 0.0;
   

   for (det_index=0; det_index<detdim; det_index++) {
      shdgr_val = shdgr[det_index];
      if (shdgr_val == 0.0) continue;
      
      length = d_allow_l[det_index];
      
      if (length == 0) continue;
            
      sky_index = d_allow_p[det_index];

      b_bot = d_allow + d_allow_st[det_index];

      while (length > 100) {
         length -= 100;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
      }
      switch (length) {
         case  99: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  98: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  97: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  96: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  95: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  94: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  93: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  92: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  91: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  90: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  89: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  88: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  87: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  86: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  85: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  84: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  83: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  82: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  81: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  80: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  79: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  78: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  77: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  76: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  75: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  74: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  73: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  72: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  71: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  70: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  69: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  68: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  67: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  66: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  65: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  64: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  63: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  62: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  61: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  60: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  59: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  58: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  57: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  56: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  55: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  54: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  53: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  52: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  51: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  50: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  49: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  48: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  47: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  46: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  45: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  44: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  43: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  42: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  41: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  40: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  39: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  38: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  37: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  36: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  35: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  34: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  33: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  32: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  31: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  30: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  29: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  28: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  27: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  26: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  25: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  24: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  23: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  22: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  21: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  20: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  19: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  18: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  17: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  16: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  15: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  14: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  13: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  12: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  11: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case  10: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case   9: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case   8: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case   7: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case   6: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case   5: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case   4: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case   3: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case   2: sky[sky_index] += shdgr_val;	sky_index += *b_bot++;
         case   1: sky[sky_index] += shdgr_val;
      }
   }
      
   /* function exit timing start */
   TT_now = clock();
   logger->func_times[func_local] += difftime(TT_now, logger->TT);
   logger->TT = TT_now;
   logger->func_calling_num = local_calling_num;
   /* function exit timing end */
   
   return(0);
}
   
/* ************************************************************************** */

int  backpro_init(char skyfil[], double parameters[], struct log_con *logger)
{
   int i, j, k, val, index_in, index_out, valsum, add, bytes, length, l_max, first = 1;
   unsigned char d_allow_x[1000];
   char skymap[128], skymapa[128], notes[1000];
   short d_allow_tmp[22501];
   FILE *datafil;
   static int func_local = -1, local_calling_num=0;
   clock_t calling_TT, TT_now;

   /* function entry timing start */
   if (func_local < 0) {
      func_local = logger->func_used_num++;
      sprintf(logger->func_names[func_local], "backpro_init");
      if (logger->func_used_num > 199) {printf("func_used_num > 199\n"); exit(0);}
   }
   logger->func_calls[func_local]++;
   calling_TT = logger->TT;
   logger->TT = TT_now = clock();
   local_calling_num = logger->func_calling_num;
   logger->func_calling_num = func_local;
   logger->func_times[local_calling_num] += difftime(TT_now, calling_TT);
   /* function entry timing end */
   
   strcpy(skymapa, skyfil);
   strcpy(skymap, skyfil);
   strcat(skymapa, ".aux");
   strcat(skymap, ".dat");

/*   sprintf(logger->tmptxt, "Backprojection files: %s  %s\n", skymap, skymapa);
   logger->logstat = logprint(logger->tmptxt, logger->lognum); 
*/   
   datafil = fopen(skymapa, "rb");	/* opening backprojection auxiliary file */
   if (datafil == NULL) {
      sprintf(logger->error_text, "\nCould not open %s, goodbye\n", skymapa);
      return(-1);
   }
   
   fread(parameters, 8, 20, datafil);
   fread(d_allow_st, 4, detdim, datafil);
   fread(d_allow_l, 2, detdim, datafil);
   fread(d_allow_p, 4, detdim, datafil);
   fread(d_allow_tmp, 2, 22501, datafil);	/* dummy read of 'maskhole' */
   fread(notes, 1, 1000, datafil);

   fclose(datafil);
   
    bytes = parameters[0];        /* length of 'd_allow' list */

   if (bytes > max_sky_bytes) {
      sprintf(logger->error_text, "\nd_allow underdimensioned, bytes = %10d", bytes);
      return(-1);
   }

  datafil = fopen(skymap, "rb");	/* opening backprojection data file */

   if (datafil == NULL) {
      sprintf(logger->error_text, "\nCould not open %s, goodbye\n", skymap);
      return(-1);
   }
   
   index_in = 0;
   
   while (bytes >= 1000) {
      fread(d_allow_x, 1, 1000, datafil);
      for (i=0; i<1000; i++) d_allow[index_in++] = (short)(d_allow_x[i]);
      bytes -= 1000;
   }
   fread(d_allow_x, 1, bytes, datafil);
   for (i=0; i<bytes; i++) d_allow[index_in++] = (short)(d_allow_x[i]);

   fclose(datafil);

   add = 0;
   l_max = 0;
   val = 0;
   for (i=0; i<detdim; i++) {
      index_in = d_allow_st[i];
      index_out = 0;
      length = d_allow_l[i];
      if (length < 2) continue;
      if (length > l_max) l_max = length;
      
      if ((first == 1) && (length >= 10) && (length <= 25)) first = 2;
      
      if (first == 2) printf("beg: val: %4d,  index: %7d,  length: %3d, d_allow_l[%5d]: %3d\n", 
         			val, index_in, length, i, d_allow_l[i]); 
      for (j=0; j<length; j++) {
         val = d_allow[index_in];
         if (first == 2) printf("%2d   val: %4d,  index: %7d,  length: %3d\n", 
            			j, val, index_in, length); 
         if (val < 255) {
            valsum = 0.0;
            while (add > 0) {
               valsum += d_allow[index_in - add];
               add--;
            }
            valsum += d_allow[index_in];
            d_allow_tmp[index_out] = valsum;
            index_out++;
         } else add++;
         index_in++; 
      }

      if (first == 2) {
         printf("end: val: %4d,  index_in: %7d,  length: %3d, d_allow_l[%5d]: %3d\n\n", 
         			val, index_in, index_out, i, d_allow_l[i]); 
         index_in = d_allow_st[i];
         for (j=0; j<length; j++) {
            printf(" %4d ", d_allow[index_in++]);
         }
         printf("\n");
         index_in = d_allow_st[i];
         for (j=0; j<index_out; j++) {
            d_allow[index_in] = d_allow_tmp[j];
            printf(" %4d ", d_allow[index_in++]);
         }
         printf("\n");
         first = 0;
      }
   }
   return(0);
}
   
/* ************************************************************************** */


