
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/timeb.h>

#include "midi_b9.h"

char progres[5] = {'F','i', 'b', ' ', '.'};
float src_maps[sourcmax][detdim];
float local_empty[detdim];
float local_norm_d[sourcmax];
float backnorm0;

int skyval(float sky[], int index, float *skval, struct log_con *logger);

/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/*                                                             */
/*  Niels Lund, February 2003                                  */        
/*                                                             */        
/*                                                             */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

int fun(int k, int ii, int ee, float srcx[], float srcy[], int jemx, float norm_d[], int last, 
   	float *value, struct euclid *g_const, struct instr_data *jmx_id, struct log_con *logger,
        struct backpro *backproj)
{
   static int src_list[sourcmax] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
   int i, j, n, ki, length, bytes, det_index, word, bitval, track_len, sxy, n2_of_illum_pix, mapdist[10];
   int ix, iy, mmpix, best_illum_pix_no, status, no_pix_in_proj_area, n3_of_illum_pix;
   char backmap[detdim], srcfilname[40];
   static unsigned char detmap[sourcmax][detdim], odetmap[detdim];
   static char initmap[detdim];
   static unsigned char sfmap[4][detdim];
   static float s_x[sourcmax], s_y[sourcmax], srcsum[4], max_vals[4], pix_cnt[4];
   float val, hdr_inf[4], max_pix_val, lysfrac, sum2;
   int comb_delta[500], track_delta[100], comb_len;
   int kt_max[4][4], det_step[4][4][16];
   float comb_list[500], track_list[100], sum, src_xy[4];
   FILE *funout;
   static int func_local = -1, local_calling_num=0;
   clock_t calling_TT, TT_now;

   /* function entry timing start */
/*   if (func_local < 0) {
      func_local = logger->func_used_num++;
      sprintf(logger->func_names[func_local], "fun");
      if (logger->func_used_num > 199) {printf("func_used_num > 199\n"); exit(0);}
   }
   logger->func_calls[func_local]++;
   calling_TT = logger->TT;
   logger->TT = TT_now = clock();
   local_calling_num = logger->func_calling_num;
   logger->func_calling_num = func_local;
   logger->func_times[local_calling_num] += TT_now - calling_TT;
*/
   /* function entry timing end */
   
   if (ii == 0) goto backgr_evaluate;
   
   *value = 0.0;

   if (k < 0) {
      for (i=0; i<sourcmax; i++) {
         src_list[i] = 0;
         norm_d[i] = 1.0;
      }
      backnorm0 = 1.0 / backproj->soft_tot[26+ee];
      for (i=0; i<detdim; i++) local_empty[i] = backproj->empty[ee][i];

      /* function exit timing start */
/*      TT_now = clock();
      logger->func_times[func_local] += difftime(TT_now, logger->TT);
      logger->TT = TT_now;
      logger->func_calling_num = local_calling_num;
*/
      /* function exit timing end */
      return(0);
   }
   
   if (backproj->soft_gr[ii] < 0.0) {
      /* function exit timing start */
/*      TT_now = clock();
      logger->func_times[func_local] += difftime(TT_now, logger->TT);
      logger->TT = TT_now;
      logger->func_calling_num = local_calling_num;
*/
      /* function exit timing end */
      return(0);
   }   
   if (k == 0) {
      if (backproj->soft_tot[26+ee] == 0.0) {
         sprintf(logger->error_text, "Pixelcount not defined for ee=%1d in 'fun'\n", ee); 
         return(-1);
      }
      *value = 1.0 / backproj->soft_tot[26+ee];
      /* function exit timing start */
/*      TT_now = clock();
      logger->func_times[func_local] += difftime(TT_now, logger->TT);
      logger->TT = TT_now;
      logger->func_calling_num = local_calling_num;
*/
      /* function exit timing end */
      return(0);
   }
   if (k == 1) {
      *value = backproj->empty[ee][ii];
      /* function exit timing start */
/*      TT_now = clock();
      logger->func_times[func_local] += difftime(TT_now, logger->TT);
      logger->TT = TT_now;
      logger->func_calling_num = local_calling_num;
*/
      /* function exit timing end */
      return(0);
   }
   
   if (k < 20) {
      if ((src_list[k] == k) && (srcx[k] == s_x[k]) && (srcy[k] == s_y[k])) goto evaluate;

/*      sprintf(logger->tmptxt, 
   		"src_list: %6d %6d %6d %6d %6d %6d\n", src_list[0], src_list[1], src_list[2], src_list[3]
      		, src_list[4], src_list[5]);
      logger->logstat = logprint(logger->tmptxt, logger->lognum); 
*/
      src_list[k] = k;
      s_x[k] = srcx[k];
      s_y[k] = srcy[k];

      if ((srcx[k] >= 0.0) && (srcx[k] < sky_xdim) && (srcy[k] >= 0.0) && (srcy[k] < sky_ydim)) ;
      else {
         sprintf(logger->error_text, "Bad XY in 'fun' srcx[%2d]; %6.1f, srcy[%2d]: %6.1f\n", k, srcx[k], k, srcy[k]);
         return(-1);
      }

      sxy = (int)(srcx[k]) * sky_ydim + (int)(srcy[k]);
      
      if (logger->test == 1) {
         sprintf(logger->tmptxt, 
            "\nFirst function call (k=%2d, sxy=%5d, jmx=%1d) with new source position: %6.2f, %6.2f, last %1d\n", 
            k, sxy, jemx+1, srcx[k], srcy[k], last);
         logger->logstat = logprint(logger->tmptxt, logger->lognum); 
      }
/* !!! */
      status = detecmap(srcx[k], srcy[k], &detmap[k][0], 0, jemx, &norm_d[k], g_const, jmx_id, logger, backproj);	

      local_norm_d[k] = norm_d[k];
      if (norm_d[k] > 0.0) ;
      else {
         sprintf(logger->error_text, "No data for sky_index %05d in 'fun'\n", sxy);
         return(-1);
      }  
      if (status < 0) return(-1);
      
      if (logger->test == 1) {
         sprintf(logger->tmptxt, "norm_d = %8.6lf\n", norm_d[k]);
         logger->logstat = logprint(logger->tmptxt, logger->lognum); 
      }
         /* calculate detector illumination from (fractional) source position */
         /* detmap contains 2 in illuminated detector pixels, and 1 in area onto which mask pattern is projected */
      track_len =  sh_depth(sxy, track_list, track_delta, jemx, jmx_id, logger, backproj);
      if (track_len < 0) return(-1);
      
         /* calculate distribution of X-ray absorbtion points relative to entry point at window level */
         /* track_list contains fraction of (1) photon arriving at detector pixels specified in track_delta */ 
      sum = 0.0;
      for (i=0; i<track_len; i++) sum += track_list[i];

/*      sprintf(logger->tmptxt, 
   		"Sum of %3d contributions along track %7.4f at energy %1d\n", track_len, sum, ee);
        logger->logstat = logprint(logger->tmptxt, logger->lognum); 
*/
      comb_len = shapecomb(track_list, track_delta, track_len, comb_list, comb_delta, logger, jmx_id);
         /* calculate combined effect of X-ray penetration into detector and position uncertainty of MS read-out */
         /* comb_list contains fraction of (1) photon arriving at detector pixels specified in comb_delta */                  if (comb_len < 0) return(-1);
      
      sum = 0.0;
      for (i=0; i<comb_len; i++) sum += comb_list[i];

/*      sprintf(logger->tmptxt, 
   		"Sum of %3d contributions around point %7.4f at energy %1d\n", comb_len, sum, ee);
      logger->logstat = logprint(logger->tmptxt, logger->lognum); 
*/    
      pix_cnt[ee] = shapefold(&detmap[k][0], comb_list, comb_delta, comb_len, &src_maps[k][0], last, logger);
      /* src_maps[k][] contains for each detector pixel the calculated fraction of 1 photon arriving from source k*/
      
      sum2 = 0.0;
      lysfrac = 0.0;
      best_illum_pix_no = 0;
      n3_of_illum_pix = 0;
      for (i=1; i<detdim; i++) {
         sum2 += src_maps[k][i];
         if (backproj->soft_gr[i] <= 0.0) src_maps[k][i] = 0.0;
         if (src_maps[k][i] > 0.0) n3_of_illum_pix++;
         if (src_maps[k][i] > lysfrac) {
            lysfrac = src_maps[k][i];
            best_illum_pix_no = i;
         }
      }
      
/*      sprintf(logger->tmptxt, 
   		"Sum of %5d contributions: %8.5lf (in total src_map (after dead-anode filter) at E%1d)\n",
                n3_of_illum_pix, sum2, ee);
      logger->logstat = logprint(logger->tmptxt, logger->lognum); 
*/    
      n2_of_illum_pix = 0;
      for (i=1; i<detdim; i++) {
         src_maps[k][i] /= sum2;
         if (detmap[k][i] > 1) n2_of_illum_pix++;
      }

      if ((last) || (logger->test == 1)){
         no_pix_in_proj_area = n2_of_illum_pix = 0;
         j = 1<<ee;
         max_pix_val = 0.0;
         mmpix = 0;
         srcsum[ee] = 0.0;
         
         for (i=0; i<detdim; i++) {

            if (ee == 0) {
               initmap[i] = 0; 
               odetmap[i] = 0;
            }
            if ((backproj->soft_gr[i] >= 0.0) && (detmap[k][i] > 0)) {
               no_pix_in_proj_area++;		/* count pixels in mask projected area */
               initmap[i] |= j;
               srcsum[ee] += src_maps[k][i];
            }

            odetmap[i] += detmap[k][i] * j * j;

            if (detmap[k][i] > 1) n2_of_illum_pix++;
            
            if (src_maps[k][i] > max_pix_val) {
               max_pix_val = src_maps[k][i];
               mmpix = i;
            }
         }
         for (i=0; i<detdim; i++) {
            sfmap[ee][i] = src_maps[k][i] * 250.0 / max_pix_val;
         }
         max_vals[ee] = 250.0 / lysfrac;

/*         sprintf(logger->tmptxt, 
"Illum_pix (E%1d): %6.0f %6d %7.1f, Recvd: %6.3f, msk prj area: %6d, norm: %10.5f, best pix; %6d/%6d, %7.5f \n",
            ee, (float)(1.0/norm_d[k]), n2_of_illum_pix, pix_cnt[ee], 
            srcsum[ee], no_pix_in_proj_area, max_pix_val, mmpix, best_illum_pix_no, lysfrac);
         logger->logstat = logprint(logger->tmptxt, logger->lognum); 
*/
      }

      /* if logger->o_ctrl > 0 output final source pattern (for diagnostic purposes) */

      if ((last > 0) && (ee == 3) && (logger->o_ctrl > 0)) {
         src_xy[0] = srcx[k];
         src_xy[1] = srcy[k];


         n = k-backproj->backmodels;
         sprintf(srcfilname, "src_patt_%03d_%03d_%1d.pat", backproj->aux_orbit, backproj->aux_pid, jemx+1);
         logger->logstat = logprint(logger->tmptxt, logger->lognum); 
         funout = fopen(srcfilname, "wb");

         hdr_inf[0] = 1.0;
         hdr_inf[1] = backproj->com_RA[n];
         hdr_inf[2] = backproj->com_dec[n];         
         hdr_inf[3] = n;
         
         fwrite(hdr_inf, 4, 4, funout);
         fwrite(srcsum, 4, 4, funout);
         fwrite(pix_cnt, 4, 4, funout);
         fwrite(max_vals, 4, 4, funout);
         fwrite(odetmap, detdim, 1, funout);

         fwrite(initmap, detdim, 1, funout);

         fwrite(sfmap, 4*detdim, 1, funout);

         fwrite(src_xy, 4, 4, funout);
         fclose(funout);
            
      }

  }

evaluate:
   if (norm_d[k] < 0.0) {
      /* function exit timing start */
/*      TT_now = clock();
      logger->func_times[func_local] += difftime(TT_now, logger->TT);
      logger->TT = TT_now;
      logger->func_calling_num = local_calling_num;
*/
      /* function exit timing end */
      return(0);
   }
   if (backproj->soft_gr[ii] >= 0.0) {
      *value = src_maps[k][ii];
      /* function exit timing start */
/*      TT_now = clock();
      logger->func_times[func_local] += difftime(TT_now, logger->TT);
      logger->TT = TT_now;
      logger->func_calling_num = local_calling_num;
*/      
      /* function exit timing end */
      return(0);
   }
   /* function exit timing start */
/*   TT_now = clock();
   logger->func_times[func_local] += difftime(TT_now, logger->TT);
   logger->TT = TT_now;
   logger->func_calling_num = local_calling_num;
*/
   /* function exit timing end */
   return(0);

backgr_evaluate:
   if (norm_d[k] < 0.0) {
      *value = 0.0;
      /* function exit timing start */
/*      TT_now = clock();
      logger->func_times[func_local] += difftime(TT_now, logger->TT);
      logger->TT = TT_now;
      logger->func_calling_num = local_calling_num;
*/
      /* function exit timing end */
      return(0);
   }
   for (i=0; i<detdim; i++) backmap[i] = 0;

   n = 0;
   for (i=0; i<detdim; i++) {
      if ((detmap[k][i] > 0.0) && (backproj->soft_gr[i] >= 0.0)) {
         n++;
         ki = i + 771;			/* pick four points around illuminated pixel (3+3 pixels away) */
         if ((ki >= 0) && (ki < detdim)) backmap[ki] = 1;
         ki = i - 771;
         if ((ki >= 0) && (ki < detdim)) backmap[ki] = 1;
         ki = i + 765;
         if ((ki >= 0) && (ki < detdim)) backmap[ki] = 1;
         ki = i - 765;
         if ((ki >= 0) && (ki < detdim)) backmap[ki] = 1;
      }
   }
   sum = 0.0;
   ki = 0;
   for (i=0; i<detdim; i++) {
      if (backmap[i] > 0) {
         ki++;
         if (backproj->soft_gr[i] >= 0.0) sum += backproj->shadw[i];
      }
   }
    
   sum *= (float)(n) / ((float)(ki) + 0.0001) ; /* background count corresponding to the illuminated pixels */
/*   sprintf(logger->tmptxt, 
      "Fun: Source %2d at energy: %1d, no. of illum. pixels: %5d, no of backgr. pixels: %6d, norm_d; %10.6f\n", 
      k, ee, n, ki, norm_d[k]);
   logger->logstat = logprint(logger->tmptxt, logger->lognum); 
*/
   *value = sum;
   
   /* function exit timing start */
/*   TT_now = clock();
   logger->func_times[func_local] += difftime(TT_now, logger->TT);
   logger->TT = TT_now;
   logger->func_calling_num = local_calling_num;
*/
   /* function exit timing end */
   
   return(0);
}

/* ************************************************************************** */

int fun2(int k, int ii, float *value, struct log_con *logger)
{

   *value = 0.0;

   if (k == 0) {
      *value = backnorm0;
      return(0);
   }
   if (k == 1) {
      *value = local_empty[ii];
      return(0);
   }
   if (local_norm_d[k] < 0.0) {
      return(0);
   }

   *value = src_maps[k][ii];
   return(0);
}
   
/* ************************************************************************** */

/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/*                                                             */
/*  Niels Lund, February 2003                                  */        
/*                                                             */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

int findpeak(float *sky, int smaxx[], int smaxy[], double amax[], float edge, 
   	struct log_con *logger, struct backpro *backproj) 

/*  Search the highest point in the backprojected sky image.
    The <access> array defines the field of view. Only the 
    maximum peak will be identified and its position will be 
    returned in <smaxx[0]> and <smaxy[0]>.
*/ 

{
      int i, j, k, jj, m, n, f, sky_index, indent = 6, m0=0, skymax, sxy_m, sxy_p;
      int remov[max_candidates+1], xsky, k_y, k_x, k_m, k_p, status; 
      double aval, blocal, m1=0.0, m2=0.0, mean, var, rms, excess, level, d_y, d_x;
      static first= 1;
      float skval;
      
      static int func_local = -1, local_calling_num=0;
      clock_t calling_TT, TT_now;

      /* function entry timing start */
      if (func_local < 0) {
         func_local = logger->func_used_num++;
         sprintf(logger->func_names[func_local], "findpeak");
         if (logger->func_used_num > 199) {printf("func_used_num > 199\n"); exit(0);}
      }
      logger->func_calls[func_local]++;
      calling_TT = logger->TT;
      logger->TT = TT_now = clock();
      local_calling_num = logger->func_calling_num;
      logger->func_calling_num = func_local;
      logger->func_times[local_calling_num] += difftime(TT_now, calling_TT);
      /* function entry timing end */
   
      blocal = -10000.0;

      for (i=0; i<skydim; i++) {	/* partially compensate for decrease in illumination at edge of FOV */
         if (backproj->illum[i] > backproj->signiflim) {
            if (edge != 0.0) sky[i] *= edge * backproj->rsignif[i];
         } else {
            sky[i] = 0.0;
         }
      }
      
      jj = k = m = 0;
      skymax = -1;
      for (j=0; j<sky_xdim; j++) {
          for (i=0; i<sky_ydim; i++) {
              sky_index = jj + i;
              if (backproj->access[sky_index] > 0) { 
                  aval = sky[sky_index];
                  m0++;
                  m1 += aval;
                  m2 += aval * aval;
                  if (aval >= blocal) {
                      smaxy[k] = i;
                      smaxx[k] = j;
                      amax[k] = aval;
                      blocal = aval;
                      skymax = sky_index;
                  }
                  m++;
              }
          }
          jj += sky_ydim;
      }
            
      if ((skymax < (3*sky_ydim+2)) || (skymax > (skydim-(3*sky_ydim+2)))) goto return_minus_one;
      if (m2 == 0.0) goto return_minus_one;
      if (m0 == 0) goto return_minus_one;
      if (sky[skymax] < 0.001) {
         sprintf(logger->tmptxt, "findpeak: sky[%d]: %9.6f\n", skymax, sky[skymax]);
         logger->logstat = logprint(logger->tmptxt, logger->lognum); 
return_minus_one:
      	 /* function exit timing start */
         TT_now = clock();
         logger->func_times[func_local] += difftime(TT_now, logger->TT);
         logger->TT = TT_now;
         logger->func_calling_num = local_calling_num;
         /* function exit timing end */
         return(-1);
      }
      
      /* calculate peak excess, and peak centroid */

      mean = m1 / m0;
      var = m2/m0 - mean * mean;
      rms = sqrt(var);
      amax[max_candidates] = rms;

      excess = blocal;
 
      status =  skyval(sky, skymax + 3, &skval, logger);
      level  = skval;
      status = +skyval(sky, skymax - 3, &skval, logger);
      level  = +skval;
      status = +skyval(sky, skymax + 3*sky_ydim, &skval, logger);
      level  = +skval;
      status = +skyval(sky, skymax - 3*sky_ydim, &skval, logger);
      level  = +skval;
      status = +skyval(sky, skymax + 3 + sky_ydim, &skval, logger);
      level  = +skval;
      status = +skyval(sky, skymax - 3 + sky_ydim, &skval, logger);
      level  = +skval;
      status = +skyval(sky, skymax + 3*sky_ydim + 1, &skval, logger);
      level  = +skval;
      status = +skyval(sky, skymax - 3*sky_ydim + 1, &skval, logger);
      level  = +skval;
      status = +skyval(sky, skymax + 3 - sky_ydim, &skval, logger);
      level  = +skval;
      status = +skyval(sky, skymax - 3 - sky_ydim, &skval, logger);
      level  = +skval;
      status = +skyval(sky, skymax + 3*sky_ydim - 1, &skval, logger);
      level  = +skval;
      status = +skyval(sky, skymax - 3*sky_ydim - 1, &skval, logger);
      level  = +skval;
 
      if (status < 0) goto return_minus_one;;
      
      level /= 6.0;
      
      sxy_p = skymax + 1;
      sxy_m = skymax - 1;
      if (sky[sxy_p] > sky[sxy_m]) {
         smaxy[1] = 1;
         excess += sky[sxy_p];
         k_y = 1;
         d_y = (sky[skymax] - sky[sxy_p]) / (sky[skymax] + sky[sxy_p] - level); 
      } else {
         smaxy[1] = -1;
         excess += sky[sxy_m];
         k_y = -1;
         d_y = (sky[sxy_m] - sky[skymax]) / (sky[skymax] + sky[sxy_m] - level);
      }

      sxy_p = skymax + sky_ydim;
      sxy_m = skymax - sky_ydim;
      if (sky[sxy_p] > sky[sxy_m]) {
         smaxx[1] = +sky_ydim;
         excess += sky[sxy_p];
         k_x = sky_ydim;
         d_x = (sky[skymax] - sky[sxy_p]) / (sky[skymax] + sky[sxy_p] - level);
      } else {
         smaxx[1] = -sky_ydim;
         excess += sky[sxy_m];
         k_x = -sky_ydim;
         d_x = (sky[sxy_m] - sky[skymax]) / (sky[skymax] + sky[sxy_m] - level);
      }
         
      excess += sky[skymax+k_y+k_x];
      excess -= level + level;
      level /= 2.0;
      amax[3] = excess;
      amax[1] = smaxx[0] + d_x;
      amax[2] = smaxy[0] + d_y;
      amax[4] = level;
      amax[5] = rms;
         
      if (logger->test == 1) {
         sprintf(logger->tmptxt, 
  "Findpeak: skymax: %5d, 4pt-excess: %6.1lf, level: %6.1lf, skymap rms: %8.2lf,  XY: %5.1lf, %5.1lf\n",
            skymax, amax[3], amax[4], amax[5], amax[1], amax[2]);
         logger->logstat = logprint(logger->tmptxt, logger->lognum); 
      }
   
   /* function exit timing start */
   TT_now = clock();
   logger->func_times[func_local] += difftime(TT_now, logger->TT);
   logger->TT = TT_now;
   logger->func_calling_num = local_calling_num;
   /* function exit timing end */
   
  return(skymax); 
}
/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

/***************************************************************/
/*                                                             */
/*  Niels Lund, February 2003                                  */        
/*                                                             */
/***************************************************************/

int imagefit(float shdg[], int jemx, int ee, float resid[], int n_source, float srcx[], float srcy[], 
       double *solut, float norm_d[], float sumfun[], int last, double *mrms, 
       struct euclid *g_const, struct instr_data *jmx_id, struct log_con *logger, struct backpro *backproj)
{
   int i, j, k, n, k1, k2, status, loclast, src_num, backmodl;
   static double mean, var, m0, m1, m2, rms;
   double mm0, mm1, mm2, mmean, mvar, r, r2, x, y;
   double coeffs[sourcmax * sourcmax], rhs[sourcmax], obs2, fun_k1;
   double coeff2[sourcmax * sourcmax], rhs2[sourcmax], rsum[27], T_k1, T_k2, T_loop; 
   float checkval, funval;
   static int icts = 0;
   static int func_local = -1, local_calling_num=0;
   clock_t calling_TT, TT_now;

   /* function entry timing start */
   if (func_local < 0) {
      func_local = logger->func_used_num++;
      sprintf(logger->func_names[func_local], "imagefit");
      if (logger->func_used_num > 199) {printf("func_used_num > 199\n"); exit(0);}
   }
   logger->func_calls[func_local]++;
   calling_TT = logger->TT;
   logger->TT = TT_now = clock();
   local_calling_num = logger->func_calling_num;
   logger->func_calling_num = func_local;
   logger->func_times[local_calling_num] += difftime(TT_now, calling_TT);
   /* function entry timing end */
   
   putchar(progres[1]);

   m0 = m1 = m2 = var = 0.0;
   backmodl = backproj->backmodels;
   
   if (n_source <= backmodl) {
      for (i=0; i<detdim; i++) {
         if (backproj->soft_gr[i] <= 0.0) continue;	/* all pixels to be rejected are <=0 in soft_gr[i] */
         m0++;
         m1 += shdg[i];
         m2 += shdg[i] * shdg[i];
      }
      mean = m1 / m0;
      var = m2/m0 - mean * mean;
      rms = sqrt(var);

      sprintf(logger->tmptxt, 
         "\nimagefit: JEM-X%1d, E=%1d, events: %10.0lf, active pix: %7.0lf, cnts/pix: %7.3lf, rms: %7.2lf\n",
         jemx+1, ee, m1, m0, mean, rms);
      logger->logstat = logprint(logger->tmptxt, logger->lognum); 
   }

   /* collect data */
   
   if (n_source > backmodl) {
      for (src_num=backmodl; src_num<n_source; src_num++) {
         loclast = 0;
         if ((last == 1) && (src_num == backmodl)) loclast = last;
         if ((last > 1) && (src_num == last)) loclast = last;

         if ((srcx[src_num] > 0.0) && (srcx[src_num] < sky_xdim) && 
             (srcy[src_num] > 0.0) && (srcy[src_num] < sky_ydim))   ;
         else {
            sprintf(logger->error_text, 
               "imagefit-1, backmodels: %1d, n_source: %2d, bad srcx[%2d] or bad %6.1f, srcy[%2d]: %6.1f\n", 
               backmodl, n_source, src_num, srcx[src_num], src_num, srcy[src_num]);
            goto return_minus_one;
         }
         if ((src_num == backmodl) && 
             (srcx[backmodl] == 0.0) && 
             (srcy[backmodl] == 0.0)) {
                sprintf(logger->error_text, "imagefit-1. Illegal call to fun\n");
                goto return_minus_one;
         }
         status = fun(src_num, detdim/2, ee, srcx, srcy, jemx, norm_d, loclast, 
            					&funval, g_const, jmx_id, logger, backproj);
            	/* initialize source functions */
         if (status < 0) goto return_minus_one;
         
         sumfun[src_num] = 0.0;
         for (j=1; j<detdim; j++) {
            if ((backproj->soft_gr[j] > 0.0) && (local_norm_d[src_num] >= 0.0)) {
/*               status = fun(src_num, j, ee, srcx, srcy, jemx, norm_d, loclast, 
            					&funval, g_const, jmx_id, logger, backproj);
*/
/*               status = fun2(src_num, j, &funval, logger); 
               if (status < 0) goto return_minus_one;
*/
               sumfun[src_num] += src_maps[src_num][j];
            }
         }
      }
   }
   
   /* n_source = backmodl (currently: 2) means:  constant + background model matching energy band */

   for (k1=0; k1<n_source; k1++) {
      rhs[k1] = 0.0;
      for (k2=0; k2<n_source; k2++) coeffs[k1*n_source+k2] = 0.0;
   }
   
   for (i=1; i<detdim; i++) {
      if (backproj->soft_gr[i] < 0.0) continue;	/* all pixels to be rejected are <0 in soft_gr */

      for (k1=0; k1<n_source; k1++) {
         if ((k1==backmodl) && (srcx[backmodl]== .0) && (srcy[backmodl]==0.0)) {
            sprintf(logger->error_text, "imagefit-2. Illegal call to fun\n");
            goto return_minus_one;
         }

/*         status = fun(k1, i, ee, srcx, srcy, jemx, norm_d, loclast, 
            					&funval, g_const, jmx_id, logger, backproj);
*/
         if (k1 == 0) funval = backnorm0;
         if (k1 == 1) funval = local_empty[i];
      	 if (k1 > 1) if (local_norm_d[k1] >= 0.0) funval = src_maps[k1][i]; else funval = 0.0;
/*	 status = fun2(k1, i, &funval, logger);
         if (status < 0) goto return_minus_one;
*/
         fun_k1 = funval;
         rhs[k1] += fun_k1 * shdg[i];
         for (k2=k1; k2<n_source; k2++) { 
            if ((srcx[k2] > 0.0) && (srcx[k2] < sky_xdim) && (srcy[k2] > 0.0) && (srcy[k2] < sky_ydim)) ;
            else {
               if (k2 >= backmodl) {
                  sprintf(logger->tmptxt, 
                     "imagefit-3, backmodels: %1d, n_source: %2d, srcx[%2d]; %6.1f, srcy[%2d]: %6.1f\n", 
                     backmodl, n_source, k2, srcx[k2], k2, srcy[k2]);
                  logger->logstat = logprint(logger->tmptxt, logger->lognum); 
               }
            }

/*            status = fun(k2, i, ee, srcx, srcy, jemx, norm_d, loclast, 
            					&funval, g_const, jmx_id, logger, backproj);
*/
            if (k2 == 0) funval = backnorm0;
            if (k2 == 1) funval = local_empty[i];
            if (k2 > 1) if (local_norm_d[k2] >= 0.0) funval = src_maps[k2][i]; else funval = 0.0;
/*	    status = fun2(k2, i, &funval, logger); 
            if (status < 0) goto return_minus_one;
*/            
            coeffs[k1 + n_source*k2] += fun_k1 * funval;
         }
      }
   }

/*   printf("Function sums: ");
*/
   for (k1=0; k1<n_source; k1++) {
      rhs2[k1] = rhs[k1];
/*      printf("\n rhs[%1d]: %lf  coeffs: ", k1, rhs[k1]); 
*/
      for (k2=k1; k2<n_source; k2++) {
         coeffs[k2+n_source*k1] = coeff2[k1+n_source*k2] = coeff2[k2+n_source*k1] = coeffs[k1+n_source*k2];
/*         printf("  k1/2:%2d/%2d coef:  %lf ", k1, k2, coeffs[k2+n_source*k1]);
*/
      }
   }
/*   printf("\n");
*/    
   for (k1=0; k1<n_source; k1++) {
      for (k2=0; k2<n_source; k2++) {
         if (rhs[k1] == 0.0) {
            sprintf(logger->tmptxt, " %lf", coeffs[k1*n_source+k2]);
            logger->logstat = logprint(logger->tmptxt, logger->lognum); 
         }

      }
      if (rhs[k1] == 0.0) {
         sprintf(logger->tmptxt, "rhs:   %lf  Source %2d is suspicious!\n", rhs[k1], k1);
         logger->logstat = logprint(logger->tmptxt, logger->lognum); 
      }
   }
   
   /* solve the equation system */
   status = gaussj_nr(coeffs, n_source, rhs, 1, logger);
   if (status < 0) {
      sprintf(logger->error_text, "In 'imagefit ': singular matrix with %d components: %2d\n", n_source, status); 
      return(status);
   }
   
   for (k1=0; k1<n_source; k1++) solut[k1] = rhs[k1];

   resid[0] = 0.0;
   for (i=1; i<detdim; i++) {
      resid[i] = 0.0;
      if (backproj->soft_gr[i] < 0.0) continue;	/* all pixels to be rejected have < in soft_gr */
      resid[i] = shdg[i];      
      for (k1=0; k1<n_source; k1++) {
         if (k1 == 0) funval = backnorm0;
         if (k1 == 1) funval = local_empty[i];
      	 if (k1 > 1) funval = src_maps[k1][i];
      	 if (k1 > 1) if (local_norm_d[k1] >= 0.0) funval = src_maps[k1][i]; else funval = 0.0;
/*         status = fun2(k1, i, &funval, logger); 
          fun(k1, i, ee, srcx, srcy, jemx, norm_d, loclast, 
            					&funval, g_const, jmx_id, logger, backproj);
         if (status < 0) goto return_minus_one;
*/
         resid[i] -= solut[k1] * funval;
      }
   }
   
/*   
   printf("\n");

   for (k1=0; k1<n_source; k1++) {
      for (k2=0; k2<n_source; k2++) {
         printf(" %8.1lf", coeffs[k1*n_source+k2]);
      }
  
      if (k1 == 0) sprintf(logger->tmptxt, 
           "grp: %2d,  Constant term,      strength:  %+10.1lf \n", k1, solut[k1]);
      if (k1 == 1) 
         sprintf(logger->tmptxt, 
            "grp: %2d,  Background model,   strength:  %+10.1lf \n", k1, solut[k1]);
      if (k1 >= backmodl) {
         sprintf(logger->tmptxt, 
            "Imagefit: grp: %2d,  XY: %6.1f/%6.1f,  strength:  %+10.1lf \n", k1, srcx[k1], srcy[k1], solut[k1]);
      }
      logger->logstat = logprint(logger->tmptxt, logger->lognum); 
   }
*/   
   mm0 = mm1 = mm2 = mvar = 0.0;

   for (i=0; i<detdim; i++) {
      if (backproj->soft_gr[i] < 0.0) continue;	/* all pixels to be rejected are <0 in soft_gr[i] */
      mm0++;
      mm1 += resid[i];
      mm2 += resid[i] * resid[i];
   }
   mmean = mm1 / mm0;
   mvar = mm2/mm0 - mmean * mmean;

   if (mvar < 0.0) {
      sprintf(logger->error_text, "In 'imagefit': negative variance after fit: %10.1lf\n", mvar);
      goto return_minus_one;
   }
/*   mrms = sqrt(mvar);   */
   *mrms = mvar;

/*   sprintf(logger->tmptxt, 
   	"JEM-X%1d, E=%1d, after fitting with %2d components.  variance: %7.4lf\n", 
      jemx+1, ee, n_source, mrms);
   logger->logstat = logprint(logger->tmptxt, logger->lognum); 
*/
   /* function exit timing start */
   TT_now = clock();
   logger->func_times[func_local] += difftime(TT_now, logger->TT);
   logger->TT = TT_now;
   logger->func_calling_num = local_calling_num;
   /* function exit timing end */
          
   return(0);
   
return_minus_one:
   /* function exit timing start */
   TT_now = clock();
   logger->func_times[func_local] += difftime(TT_now, logger->TT);
   logger->TT = TT_now;
   logger->func_calling_num = local_calling_num;
   /* function exit timing end */
          
   return(-1);
}

/* **************************************************************** */

/* **************************************************************** */

int gaussj_nr(double a[], int n, double b[], int m, struct log_con *logger)

/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/*                                                             */
/*  Niels Lund, February 2003                                  */        
/*                                                             */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

/* -------------------------------------------------------------

docbegin:

*  Name of source file:
*         /home/nl/jemx/ipfread/jemx1-2/sky/gaussj_nr.c

*  Version of source file:      0.00
*  Parent component:            gaussj_nr from NJW 
*  Programmer:                  Niels Lund (modification to avoid DAL/PIL/RIL dependencies)
*  Affiliation:                 Danish Space Research Institute
*  Purpose:                     Fit of shadowgram components for Iterative Removal of Sources
*  Origin date:                 021220
*  Update history:
*  Type of element:             Function
*  Part of package:             minisky.c
*  Required functions		SWAP
Various remarks:

Gauss-Jordan matrix inversion from "Numerical Recipes"
adapted to follow the storage convention:		    a(i,j) = a[j*Ni + i]

-------------------------------------------------------------- */
{
   int icol, irow, i, j, k, l, ll;
   int indxc[20], indxr[20], ipiv[20];
   double big, dum, pivinv;

   static int func_local = -1, local_calling_num=0;
   clock_t calling_TT, TT_now;

   /* function entry timing start */
   if (func_local < 0) {
      func_local = logger->func_used_num++;
      sprintf(logger->func_names[func_local], "gaussj_nr");
      if (logger->func_used_num > 199) {printf("func_used_num > 199\n"); exit(0);}
   }
   calling_TT = logger->TT;
   logger->func_calls[func_local]++;
   logger->TT = TT_now = clock();
   local_calling_num = logger->func_calling_num;
   logger->func_calling_num = func_local;
   logger->func_times[local_calling_num] += difftime(TT_now, calling_TT);
   /* function entry timing end */
   
   for (j=0;j<n;j++) ipiv[j]=0;
   for (i=0;i<n;i++) {
      big=0.0;
      for (j=0;j<n;j++)
         if (ipiv[j] != 1)
            for (k=0;k<n;k++) {
               if (ipiv[k] == 0) {
                  if (fabs(a[k*n+j]) >= big) {
                     big=fabs(a[k*n+j]);
                     irow=j;
                     icol=k;
                  }
               } else {
                  if (ipiv[k] > 1) {
                     /* function exit timing start */
                     TT_now = clock();
                     logger->func_times[func_local] += difftime(TT_now, logger->TT);
                     logger->TT = TT_now;
                     logger->func_calling_num = local_calling_num;
                     /* function exit timing end */
                     return(-1);	/* singular matrix 1 */
                  }
               }
            }
      ++(ipiv[icol]);
      
      if (irow != icol) {
         for (l=0;l<n;l++) SWAP(a[l*n + irow],a[l*n + icol]);
         for (l=0;l<m;l++) SWAP(b[l*n + irow],b[l*n + icol]);
      }
      indxr[i]=irow;
      indxc[i]=icol;
      if (a[icol*n + icol] == 0.0) {
         /* function exit timing start */
         TT_now = clock();
         logger->func_times[func_local] += difftime(TT_now, logger->TT);
         logger->TT = TT_now;
         logger->func_calling_num = local_calling_num;
         /* function exit timing end */
          
         return(-2);	/* singular matrix 2 */
      }
      
      pivinv=1.0/a[icol*n + icol];
      a[icol*n + icol]=1.0;
      for (l=0;l<n;l++) a[l*n + icol] *= pivinv;
      for (l=0;l<m;l++) b[l*n + icol] *= pivinv;
      for (ll=0;ll<n;ll++)
         if (ll != icol) {
            dum=a[icol*n + ll];
            a[icol*n + ll]=0.0;
            for (l=0;l<n;l++) a[l*n + ll] -= a[l*n + icol]*dum;
            for (l=0;l<m;l++) b[l*n + ll] -= b[l*n + icol]*dum;
         }
   }
   for (l=n-1;l>=0;l--) {
      if (indxr[l] != indxc[l])
         for (k=0;k<n;k++)
            SWAP(a[indxr[l]*n + k],a[indxc[l]*n + k]);
   }
   
   /* function exit timing start */
   TT_now = clock();
   logger->func_times[func_local] += difftime(TT_now, logger->TT);
   logger->TT = TT_now;
   logger->func_calling_num = local_calling_num;
   /* function exit timing end */
          
   return(0);
}

/* **************************************************************** */

int skyval(float sky[], int index, float *skval, struct log_con *logger)
{
   static int func_local = -1, local_calling_num=0;
   clock_t calling_TT, TT_now;

   /* function entry timing start */
   if (func_local < 0) {
      func_local = logger->func_used_num++;
      sprintf(logger->func_names[func_local], "skyval");
      if (logger->func_used_num > 199) {printf("func_used_num > 199\n"); exit(0);}
   }
   logger->func_calls[func_local]++;
   calling_TT = logger->TT;
   logger->TT = TT_now = clock();
   local_calling_num = logger->func_calling_num;
   logger->func_calling_num = func_local;
   logger->func_times[local_calling_num] += difftime(TT_now, calling_TT);
   /* function entry timing end */
   
   /* function exit timing start */
   TT_now = clock();
   logger->func_times[func_local] += difftime(TT_now, logger->TT);
   logger->TT = TT_now;
   logger->func_calling_num = local_calling_num;
   /* function exit timing end */
          
   if ((index >= 0) && (index < skydim)) {
      *skval = sky[index];
      return(0);
   }
   sprintf(logger->error_text , "Illegal sky index in 'skyval': %8d\n", index);   
   return(-1);
}
